<template>
  <div class="actNum pagePadding">
    <ex-table
      v-loading="loading"
      :table="table"
      :data="tableData"
      :columns="columns"
      :page="pageInfo"
      :size="size"
      @page-curr-change="handlePageChange"
      @page-size-change="handleSizeChange"
      @screen-reset="
        pageInfo.curr = 1;
        parmValue.page = 1;
        searchList();
      "
      @screen-submit="
        pageInfo.curr = 1;
        parmValue.page = 1;
        searchList();
      "
    >
      <template #table-header="{}">
        <div style="width: 100%">
          <el-row style="padding: 0 0 0 80px">
            <!-- <el-col :span="4" style="margin-right: 10px">
              <el-input
                :size="searchSize"
                v-model="parmValue.name"
                :maxlength="40"
                clearable
                @blur="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
                @clear="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
                placeholder="活动人数"
              ></el-input>
            </el-col> -->

            <el-col :span="4" style="width: 160px">
              <el-select
                v-model="parmValue.status"
                filterable
                clearable
                :size="searchSize"
                placeholder="状态"
                style="width: 100%"
                @change="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
              >
                <el-option
                  v-for="item in statusList"
                  :key="'status' + item.code"
                  :label="item.name"
                  :value="item.code"
                />
              </el-select>
            </el-col>

            <el-col :span="3" class="fr" style="width: 66px; padding: 0 0 0 10px">
              <el-button type="primary" :size="searchSize" @click="searchList">
                刷新
              </el-button>
            </el-col>
            <el-col :span="3" class="fr" style="width: 66px; padding: 0 0 0 10px">
              <el-button type="warning" :size="searchSize" @click="restSearch">
                重置
              </el-button>
            </el-col>
            <el-col
              :span="3"
              class="fr"
              style="width: 66px; padding: 0 0 0 10px"
              v-if="powers.some((i) => i == '002')"
            >
              <el-button
                :size="searchSize"
                type="success"
                style="float: right"
                @click="openModal({}, '002', '0')"
              >
                添加
              </el-button>
            </el-col>
          </el-row>
        </div></template
      >

      <template #name="{ scope }">
        <span v-if="String(scope.row.max) === '0'">{{ scope.row.min }}+ 人</span>
        <span v-else>{{ scope.row.min }}~{{ scope.row.max }} 人</span>
      </template>
      <template #status="{ scope }">
        <el-tag
          :size="tablebtnSize"
          :type="scope.row.status == '0' ? 'warning' : ''"
          v-text="
            (
              statusList.find((item) => Number(item.code) == Number(scope.row.status)) ||
              {}
            ).name || '--'
          "
        ></el-tag>
      </template>

      <template #operation="{ scope }">
        <el-tooltip effect="dark" content="详情" placement="top">
          <i
            class="el-icon-view tb-icon"
            @click="openModal(scope.row, '007', scope.row.status)"
          ></i>
        </el-tooltip>
        <el-tooltip
          v-if="powers.some((i) => i == '005')"
          effect="dark"
          content="修改"
          placement="top"
        >
          <i
            class="el-icon-edit tb-icon"
            @click="openModal(scope.row, '005', scope.row.status)"
          ></i>
        </el-tooltip>
        <el-tooltip
          v-if="powers.some((i) => i == '004') && scope.row.status + '' === '1'"
          effect="dark"
          content="禁用"
          placement="top"
        >
          <i
            class="el-icon-video-pause tb-icon"
            @click="changeStatus(scope.row.id, scope.row.status)"
          ></i>
        </el-tooltip>
        <el-tooltip
          v-if="powers.some((i) => i == '003') && scope.row.status + '' === '0'"
          effect="dark"
          content="启用"
          placement="top"
        >
          <i
            class="el-icon-video-play tb-icon"
            @click="changeStatus(scope.row.id, scope.row.status)"
          ></i>
        </el-tooltip>
        <el-tooltip
          v-if="powers.some((i) => i == '006')"
          effect="dark"
          content="删除"
          placement="top"
        >
          <i class="el-icon-delete tb-icon" @click="deleteItem(scope.row.id)"></i>
        </el-tooltip>
      </template>
    </ex-table>
    <!-- 弹窗 新增/修改 -->
    <add-edit
      :id="modelId"
      :show-model="showModel"
      :sitem="sitem"
      @refresh="searchList"
      @cancel="showModel = false"
    />
  </div>
</template>
<script>
import addEdit from "./addEdit";
import asyncRequest from "@/apis/service/serviceParam/actNum";
import { statusList } from "@/assets/js/statusList";
import mixinPage from "@/mixins/elPaginationHandle";
import { mapGetters } from "vuex";
import resToken from "@/mixins/resToken";
export default {
  name: "actNum",
  mixins: [mixinPage, resToken],
  components: {
    addEdit,
  },
  computed: {
    //组件SIZE设置
    ...mapGetters(["tablebtnSize", "searchSize", "size"]),
    powers() {
      const tran =
        this.$store.getters.btnList.find((i) => i.menu_route == "actNum") || {};
      const { action } = tran ?? {};
      return action ?? [];
    },
  },
  data() {
    return {
      statusList,
      loading: false,
      showModel: false,
      modelId: "000",
      sitem: {},
      parmValue: {
        page: 1, // 页码
        size: 15, // 每页显示条数
        status: "",
        name: "",
      },
      // 表格 - 数据
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },
      // 表格 - 列参数
      columns: [
        {
          prop: "name",
          label: "活动人数",
          _slot_: "name",
        },
        {
          prop: "status",
          label: "状态",
          _slot_: "status",
        },
        {
          prop: "create_time",
          label: "创建时间",
        },
        {
          prop: "",
          label: "操作",
          fixed: "right",
          _noset_: true,
          _slot_: "operation",
        },
      ],
    };
  },
  mounted() {
    this.searchList();
  },
  methods: {
    restSearch() {
      // 表格 - 分页
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0,
      };
      this.parmValue = {
        page: 1, // 页码
        size: 15, // 每页显示条数
        name: "",
        status: "",
      };
      this.searchList();
    },
    // 新建/编辑/详情
    openModal(row, type, status) {
      if (type === "005" && status + "" === "1") {
        this.$message.warning("禁用后，才可以修改！");
        return;
      }
      this.sitem = row;
      this.modelId = type;
      this.showModel = true;
    },
    /**
     * 启用/禁用
     * @param {String} id id
     * @param {String} status 0-禁用 1-启用
     */
    async changeStatus(id, status) {
      await this.$confirm(`确定要改为${status + "" === "1" ? "禁用" : "启用"}？`, {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          this.loading = true;
          const model = {
            id: id,
            status: status + "" === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          this.loading = false;
          if (res && res.code === 1) {
            this.$notify.success({
              title: "状态修改成功！",
              message: "",
            });
            await this.searchList();
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    async deleteItem(id) {
      await this.$confirm("确定要删除？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          const model = {
            ids: id,
          };
          const res = await asyncRequest.delete(model);
          if (res && res.code === 1) {
            this.$notify.success({
              title: "删除成功",
              message: "",
            });
            this.searchList();
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    // 刷新表格
    async searchList() {
      if (this.loading) return;
      this.loading = true;
      const model = {
        ...this.parmValue,
        limit: this.parmValue.size,
      };
      const { code, data } = await asyncRequest.list(model);
      if (code === 1) {
        const { list, total } = data;
        this.tableData = list;
        this.pageInfo.total = Number(total);
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }
      this.loading = false;
    },
  },
};
</script>

<style lang="scss" scoped></style>
